Build Apple's llvmCore with --disable-zlib. <rdar://problem/14182316>
[oota-llvm.git] / utils / buildit / build_llvm
1 #!/bin/sh
2 # LLVM LOCAL file B&I
3
4 set -x
5
6 # Build LLVM the "Apple way".
7 # Parameters:
8
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 HOSTS="$1"
13
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
18 TARGETS="$2"
19
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
23
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
27
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
31
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
36
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
40
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
44
45 # A yes/no parameter that controls whether to cross-build for an ARM host.
46 ARM_HOSTED_BUILD="$9"
47
48 # A yes/no parameter that controls whether to cross-build for the iOS simulator
49 IOS_SIM_BUILD="${10}"
50
51 # The version number of the submission, e.g. 1007.
52 LLVM_SUBMIT_VERSION="${11}"
53
54 # The subversion number of the submission, e.g. 03.
55 LLVM_SUBMIT_SUBVERSION="${12}"
56
57 # The current working directory is where the build will happen. It may already
58 # contain a partial result of an interrupted build, in which case this script
59 # will continue where it left off.
60 DIR=`pwd`
61
62 DARWIN_VERS=`uname -r | sed 's/\..*//'`
63 echo DARWIN_VERS = $DARWIN_VERS
64
65 ################################################################################
66 # Run the build.
67
68 # Create the source tree we'll actually use to build, deleting
69 # tcl since it doesn't actually build properly in a cross environment
70 # and we don't really need it.
71 SRC_DIR=$DIR/src
72 rm -rf $SRC_DIR || exit 1
73 mkdir $SRC_DIR || exit 1
74 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
75 # We can't use the top-level Makefile as-is.  Remove the soft link:
76 rm $SRC_DIR/Makefile || exit 1
77 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
78 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
79
80 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/.*\.\([0-9]*\).*/\1/'`
81 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
82     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
83     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
84     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
85 fi
86 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
87     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
88 else
89     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
90 fi
91
92 # Figure out how many make processes to run.
93 SYSCTL=`sysctl -n hw.activecpu`
94 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
95 # Builders can default to 2, since even if they are single processor,
96 # nothing else is running on the machine.
97 if [ -z "$SYSCTL" ]; then
98     SYSCTL=2
99 fi
100 JOBS_FLAG="-j $SYSCTL"
101
102 COMMON_CONFIGURE_OPTS="\
103   --prefix=$DEST_DIR$DEST_ROOT \
104   --enable-assertions=$LLVM_ASSERTIONS \
105   --enable-optimized=$LLVM_OPTIMIZED \
106   --disable-bindings \
107   --disable-zlib"
108
109 COMMON_MAKEFLAGS="\
110   UNIVERSAL=1 \
111   UNIVERSAL_SDK_PATH=$SDKROOT \
112   NO_RUNTIME_LIBS=1 \
113   DISABLE_EDIS=1 \
114   REQUIRES_RTTI=1 \
115   DEBUG_SYMBOLS=1 \
116   LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
117   LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
118   VERBOSE=1"
119
120 # Build the LLVM tree universal.
121 mkdir -p $DIR/obj-llvm || exit 1
122 cd $DIR/obj-llvm || exit 1
123
124 if [ "$ARM_HOSTED_BUILD" = yes ]; then
125   # The cross-tools' build process expects to find an existing cross toolchain
126   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
127   rm -rf $DIR/bin || exit 1
128   mkdir $DIR/bin || exit 1
129   for prog in ar nm ranlib strip lipo ld as ; do
130     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
131     T=`xcrun -sdk $SDKROOT -find ${prog}`
132     ln -s $T $DIR/bin/$prog
133     echo '#!/bin/sh' > $P || exit 1
134     echo 'exec '$T' "$@"' >> $P || exit 1
135     chmod a+x $P || exit 1
136   done
137   # Set up the links for clang.
138   for prog in clang clang++ ; do
139     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
140     T=`xcrun -sdk $SDKROOT -find ${prog}`
141     ln -s $T $DIR/bin/$prog
142     echo '#!/bin/sh' > $P || exit 1
143     echo 'exec '$T' -arch armv7 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
144     chmod a+x $P || exit 1
145   done
146
147   PATH=$DIR/bin:$PATH
148
149   unset SDKROOT && \
150   $SRC_DIR/configure $COMMON_CONFIGURE_OPTS \
151     --enable-targets=arm \
152     --host=arm-apple-darwin10 \
153     --target=arm-apple-darwin10 \
154     --build=i686-apple-darwin10 \
155     --program-prefix="" \
156     || exit 1
157
158   if [ -n "$IPHONEOS_DEPLOYMENT_TARGET" ]; then
159     COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
160       DEPLOYMENT_TARGET=-mios-version-min=$IPHONEOS_DEPLOYMENT_TARGET"
161   fi
162
163   make $JOBS_FLAG $COMMON_MAKEFLAGS SDKROOT= UNIVERSAL_ARCH="$HOSTS" \
164     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'"
165   if [ $? != 0 ] ; then
166     echo "error: LLVM 'make' failed!"
167     exit 1
168   fi 
169
170 else
171 # not $ARM_HOSTED_BUILD
172
173   export CC=`xcrun -find clang`
174   export CXX=`xcrun -find clang++`
175
176   if [ "$IOS_SIM_BUILD" = yes ]; then
177     # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
178     configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
179                     --build=i686-apple-darwin10"
180     if [ -n "$IPHONEOS_DEPLOYMENT_TARGET" ]; then
181       COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
182         DEPLOYMENT_TARGET=-mios-simulator-version-min=$IPHONEOS_DEPLOYMENT_TARGET"
183     fi
184   else
185     configure_opts="--enable-targets=arm,x86"
186     if [ -n "$MACOSX_DEPLOYMENT_TARGET" ]; then
187       COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
188         DEPLOYMENT_TARGET=-mmacosx-version-min=$MACOSX_DEPLOYMENT_TARGET"
189     fi
190   fi
191
192   if [ $SDKROOT ]; then
193     CPPFLAGS="$CPPFLAGS -isysroot $SDKROOT"
194   fi
195   for host in $HOSTS; do :; done
196   CPPFLAGS="$CPPFLAGS -arch $host"
197
198   $SRC_DIR/configure $COMMON_CONFIGURE_OPTS $configure_opts \
199     --program-prefix="" \
200     CPPFLAGS="$CPPFLAGS" \
201     || exit 1
202
203   make $JOBS_FLAG $COMMON_MAKEFLAGS UNIVERSAL_ARCH="$HOSTS" \
204     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'"
205   if [ $? != 0 ] ; then
206     echo "error: LLVM 'make' failed!"
207     exit 1
208   fi 
209 fi 
210
211 ################################################################################
212 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
213 # $DEST_DIR, with occasional 'lipo' commands.
214
215 cd $DEST_DIR || exit 1
216
217 # Clean out DEST_DIR in case -noclean was passed to buildit.
218 rm -rf * || exit 1
219
220 cd $DIR/obj-llvm || exit 1
221
222 # Install the tree into the destination directory.
223 make $JOBS_FLAG $COMMON_MAKEFLAGS UNIVERSAL_ARCH="$HOSTS" install
224 if ! test $? == 0 ; then
225     echo "error: LLVM 'make install' failed!"
226     exit 1
227 fi 
228
229 # Install Version.h
230 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
231 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
232     LLVM_MINOR_VERSION=0
233 fi
234 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
235 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
236 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
237
238 # Run unifdef to preprocess the installed headers to reflect whether this
239 # was a debug or release build.
240 for file in `find $DEST_DIR$DEST_ROOT/include -type f -print`; do
241   if [ "$LLVM_ASSERTIONS" = yes ]; then
242     unifdef -UNDEBUG -D_DEBUG -o $file $file
243   else
244     unifdef -DNDEBUG -U_DEBUG -ULLVM_ENABLE_DUMP -o $file $file
245   fi
246 done
247
248 # Find the right version of strip to use.
249 STRIP=strip
250 if [ -n "$SDKROOT" ]; then
251   STRIP=`xcrun -sdk $SDKROOT -find strip`
252 fi
253
254 if [ "x$LLVM_DEBUG" != "x1" ]; then
255     # Strip local symbols from llvm libraries.
256     #
257     # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
258     # PPC objects!
259     $STRIP -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
260     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
261         $STRIP -Sxl $f
262     done
263 fi
264
265 # Remove .dir files 
266 cd $DEST_DIR$DEST_ROOT
267 rm -f bin/.dir etc/llvm/.dir lib/.dir
268
269 # The Hello dylib is an example of how to build a pass.
270 # The BugpointPasses module is only used to test bugpoint.
271 # These unversioned dylibs cause verification failures, so do not install them.
272 # (The wildcards are used to match a "lib" prefix if it is present.)
273 rm $DEST_DIR$DEST_ROOT/lib/*LLVMHello.dylib
274 rm $DEST_DIR$DEST_ROOT/lib/*BugpointPasses.dylib
275
276 # Compress manpages
277 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
278 gzip -f $MDIR/*
279
280 ################################################################################
281 # Create SYM_DIR with information required for debugging.
282
283 # Figure out how many make processes to run.
284 SYSCTL=`sysctl -n hw.activecpu`
285
286 # hw.activecpu only available in 10.2.6 and later
287 if [ -z "$SYSCTL" ]; then
288   SYSCTL=`sysctl -n hw.ncpu`
289 fi
290
291 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
292 # can default to 2, since even if they are single processor, nothing else is
293 # running on the machine.
294 if [ -z "$SYSCTL" ]; then
295   SYSCTL=2
296 fi
297
298 cd $SYM_DIR || exit 1
299
300 # Clean out SYM_DIR in case -noclean was passed to buildit.
301 rm -rf * || exit 1
302
303 # Generate .dSYM files
304 DSYMUTIL=`xcrun -find dsymutil`
305 find $DEST_DIR -perm -0111 -type f \
306     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
307     -print | xargs -n 1 -P ${SYSCTL} ${DSYMUTIL}
308
309 # Save .dSYM files and .a archives
310 cd $DEST_DIR || exit 1
311 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
312     | cpio -pdml $SYM_DIR || exit 1
313
314 # Save source files.
315 mkdir $SYM_DIR/src || exit 1
316 cd $DIR || exit 1
317 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
318     | cpio -pdml $SYM_DIR/src || exit 1
319
320 ################################################################################
321 # Remove libLTO.dylib and lto.h.  Those are installed by clang.
322
323 cd $DEST_DIR$DEST_ROOT
324 rm -f lib/libLTO.dylib
325 rm -f lib/libLTO.a lib/libLTO.la
326 find $DEST_DIR$DEST_ROOT -name lto.h -delete
327
328 ################################################################################
329 # Remove debugging information from DEST_DIR.
330
331 cd $DIR || exit 1
332
333 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
334 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
335
336 # Strip debugging information from files
337 #
338 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
339 # PPC objects!
340 find $DEST_DIR -perm -0111 -type f \
341     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
342     -print | xargs -n 1 -P ${SYSCTL} $STRIP -arch all -Sl
343
344 chgrp -h -R wheel $DEST_DIR
345 chgrp -R wheel $DEST_DIR
346
347 ################################################################################
348 # Remove the docs directory
349
350 rm -rf $DEST_DIR$DEST_ROOT/docs
351
352 ################################################################################
353 # w00t! Done!
354
355 exit 0